
# --------------------------------------------
# It generates the polychrony command 
# It assumes that CMD is fixed.
# --------------------------------------------
SET(CONFIG_FILE ${SignalGUI_bin}/${CMD})
GEN_HEADER_SCRIPT(${CONFIG_FILE})

GEN_REQUIRE_SHELL_VAR(${CONFIG_FILE} pK_ROOT)
GEN_REQUIRE_SHELL_VAR(${CONFIG_FILE} SignalGUI_bin)
GEN_REQUIRE_FILE(${CONFIG_FILE} SignalGUI_bin "sigGUIHelp.txt") 

IF(UNIX)
  FILE(APPEND ${CONFIG_FILE} "if ( \"$1\" == \"-h\" ) then\n")
  FILE(APPEND ${CONFIG_FILE} "     more \${SignalGUI_bin}/sigGUIHelp.txt\n")
  FILE(APPEND ${CONFIG_FILE} "     exit -1\n")
  FILE(APPEND ${CONFIG_FILE} "endif\n")
  FILE(APPEND ${CONFIG_FILE} "\n")
 
  FILE(APPEND ${CONFIG_FILE} "if ( \"$1\" == \"-vers\" ) then\n")
  FILE(APPEND ${CONFIG_FILE} "     echo \"current Polychrony Signal GUI is $SignalGUI_VERSION located in $SignalGUI_bin\"\n")
  FILE(APPEND ${CONFIG_FILE} "     echo \"current Polychrony Signal compiler version is \${pK_VERSION} located in $Signal_bin\"\n")
  FILE(APPEND ${CONFIG_FILE} "     exit -1\n")
  FILE(APPEND ${CONFIG_FILE} "endif\n")
  FILE(APPEND ${CONFIG_FILE} "\n")

  GEN_REQUIRE_SHELL_VAR(${CONFIG_FILE} SignalGUI_obj)
  FILE(APPEND ${CONFIG_FILE} "# ----------\n")
  FILE(APPEND ${CONFIG_FILE} "if ( $?LD_LIBRARY_PATH ) then\n")
  FILE(APPEND ${CONFIG_FILE} "   if ( `echo $LD_LIBRARY_PATH | egrep -c \"$SignalGUI_bin\"` == 0 ) then \n")
  FILE(APPEND ${CONFIG_FILE} "     setenv LD_LIBRARY_PATH \"\${LD_LIBRARY_PATH}:\${SignalGUI_bin}:\${SignalGUI_obj}\"\n")
  FILE(APPEND ${CONFIG_FILE} "   endif\n")
  FILE(APPEND ${CONFIG_FILE} "   else\n")
  FILE(APPEND ${CONFIG_FILE} "     setenv LD_LIBRARY_PATH \${SignalGUI_obj}:\${SignalGUI_bin}\n")
  FILE(APPEND ${CONFIG_FILE} "endif\n")
  FILE(APPEND ${CONFIG_FILE} "# ----------\n")
  FILE(APPEND ${CONFIG_FILE} "if ( $?JAVA_LIBRARY_PATH ) then\n")
  FILE(APPEND ${CONFIG_FILE} "   if ( `echo $JAVA_LIBRARY_PATH | egrep -c \"$SignalGUI_bin\"` == 0 ) then \n")
  FILE(APPEND ${CONFIG_FILE} "       setenv JAVA_LIBRARY_PATH \"\${JAVA_LIBRARY_PATH}:\${SignalGUI_bin}:\${SignalGUI_obj}\"\n")
  FILE(APPEND ${CONFIG_FILE} "   endif\n")
  FILE(APPEND ${CONFIG_FILE} "   else\n")
  FILE(APPEND ${CONFIG_FILE} "       setenv JAVA_LIBRARY_PATH \${SignalGUI_obj}:\${SignalGUI_bin}\n")
  FILE(APPEND ${CONFIG_FILE} "endif\n")
  FILE(APPEND ${CONFIG_FILE} "# ----------\n")
  FILE(APPEND ${CONFIG_FILE} "if ( ! $?SigaliCmdForPolychrony ) then\n")
  FILE(APPEND ${CONFIG_FILE} "     setenv SigaliCmdForPolychrony \"\"\n")
  FILE(APPEND ${CONFIG_FILE} "endif\n")
  FILE(APPEND ${CONFIG_FILE} "setenv LOGFILE \"polychrony.log\"\n")
  GEN_SHELL_VAR_IF_NOTDEFINED(${CONFIG_FILE} T_MEM_ARB 60000000 "Tree memory parameter (optional)\n")
  GEN_SHELL_VAR_IF_NOTDEFINED(${CONFIG_FILE} T_MEM_CHAIN 1048576 "String memory parameter (optional)\n")
  GEN_SHELL_VAR_IF_NOTDEFINED(${CONFIG_FILE} SHELL_TypeTableMaxSize  4096 "Size of the type table(optional)\n")
  FILE(APPEND ${CONFIG_FILE} "\\rm $LOGFILE\n")
  FILE(APPEND ${CONFIG_FILE} "echo \"Polychrony Signal GUI - version $SignalGUI_VERSION\"\n")
  FILE(APPEND ${CONFIG_FILE} "echo \"Copyright (c) INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010\"\n")
  FILE(APPEND ${CONFIG_FILE} "java -classpath \${SignalGUI_obj}/SignalGUI.jar gui_dependent.Polychrony $PWD  \${SignalGUIBin_images} \${SignalGUIBin_doc} $* > & $LOGFILE &\n")
ELSE(UNIX)
  FILE(APPEND ${CONFIG_FILE} "@echo off\n")
  FILE(APPEND ${CONFIG_FILE} "\n")
  FILE(APPEND ${CONFIG_FILE} "rem %~dp0 is expanded pathname of the current script under NT\n")
  FILE(APPEND ${CONFIG_FILE} "set cmdDirName=%~dp0\n")
  FILE(APPEND ${CONFIG_FILE} "\n")
  FILE(APPEND ${CONFIG_FILE} "if  not defined SignalGUI_bin call \"%cmdDirName%\\..\\..\\polychronyEnv.bat\"\n")
  FILE(APPEND ${CONFIG_FILE} "\n")

  FILE(APPEND ${CONFIG_FILE} "if not \"%1%\"==\"-h\" goto nothelp\n")
  FILE(APPEND ${CONFIG_FILE} "   more \"%SignalGUI_bin%\\sigGUIHelp.txt\"\n")
  FILE(APPEND ${CONFIG_FILE} "goto end\n")
  FILE(APPEND ${CONFIG_FILE} "\n")
  
  FILE(APPEND ${CONFIG_FILE} ":nothelp\n")
  FILE(APPEND ${CONFIG_FILE} "if not \"%1%\"==\"-vers\" goto notvers\n")
  FILE(APPEND ${CONFIG_FILE} "@echo Polychrony Signal GUI version is %SignalGUI_VERSION% located in %SignalGUI_bin% \n")
  FILE(APPEND ${CONFIG_FILE} "@echo Polychrony Signal compiler version is %pK_VERSION% located in %Signal_bin% \n")
  FILE(APPEND ${CONFIG_FILE} "goto end\n")
  FILE(APPEND ${CONFIG_FILE} "\n")

  FILE(APPEND ${CONFIG_FILE} ":notvers\n")
  FILE(APPEND ${CONFIG_FILE} "set PATH=%PATH%;%JAVA_BIN%\n")
  FILE(APPEND ${CONFIG_FILE} "\n")
  FILE(APPEND ${CONFIG_FILE} "set PATH=%PATH%;%SignalGUI_bin%;%SignalGUI_obj%\n")
  FILE(APPEND ${CONFIG_FILE} "set JAVA_LIBRARY_PATH=%SignalGUI_bin%;%SignalGUI_obj%\n")
  FILE(APPEND ${CONFIG_FILE} "\n")
  FILE(APPEND ${CONFIG_FILE} "set PWD= %CD%\n")
  FILE(APPEND ${CONFIG_FILE} "\n")
  GEN_SHELL_VAR_IF_NOTDEFINED(${CONFIG_FILE} T_MEM_ARB 60000000 "Tree memory parameter (optional)\n")
  GEN_SHELL_VAR_IF_NOTDEFINED(${CONFIG_FILE} T_MEM_CHAIN 1048576 "String memory parameter (optional)\n")
  GEN_SHELL_VAR_IF_NOTDEFINED(${CONFIG_FILE} SHELL_TypeTableMaxSize  4096 "Size of the type table(optional)\n")
  FILE(APPEND ${CONFIG_FILE} "\n")
  FILE(APPEND ${CONFIG_FILE} "@echo Polychrony Signal GUI - version %SignalGUI_VERSION%\n")
  FILE(APPEND ${CONFIG_FILE} "@echo Copyright (c) INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010\n")
  FILE(APPEND ${CONFIG_FILE} "java -classpath \"%SignalGUI_obj%\\SignalGUI.jar\" gui_dependent.Polychrony \"%PWD%\"  \"%SignalGUIBin_images%\" \"%SignalGUIBin_doc%\" %*\n")
  FILE(APPEND ${CONFIG_FILE} ":end\n")
  FILE(APPEND ${CONFIG_FILE} "\n")

ENDIF(UNIX)
ADD_EXECUTE_RIGHT(${CONFIG_FILE})
